BW.model <- function(t, Initial.Values, Parameters, input.T) { 
  
  with( as.list(c(Initial.Values, Parameters)),{
    
    # Temperature
    TC_k = input.T(t) + 273.15 # (degree K)
    TC_c = input.T(t)          # (degree C)
    
    # body weight : DEB growth model anisomorphic
    DEB_v_t   = DEB_v  * KT(T=TC_k , TR=TR_DEB ,TA=TA) # mm/d 
    DEB_Lm    = DEB_v / (DEB_KM * DEB_g)                # mm  
    DEB_M     = (DEB_EHm / DEB_EHb)^(1/3)               # EHm and EHb = J
    dL        = (DEB_v_t / (3 * (f_cst + DEB_g))) * (f_cst * DEB_M - (L/DEB_Lm)) 
    BW        = a_BW_L *( (L/10)/DEB_shape ) ^ b_BW_L # BW = g; a = g/cm;  L = mm --> /10 = cm
    
    list("Q"=c(dL), # derivatives
         "BW"      = BW)
  }) }